#include "classboss.h"

#include "classmap.h"

#include "timerlib.h"
extern timerLib timer;

#include "scenes/dialogs.h"

#include "defines.h"
#include <cmath>
#include <cstdlib>
#include "game.h"
extern game gameControl;

#include "soundlib.h"
extern soundLib soundManager;


extern CURRENT_FILE_FORMAT::file_game game_data;

#define BOSS_HIT_DURATION 1000

classboss::classboss(std::string set_name) : _initialized(0), _screen_blinked(false)
{
	name = set_name;
    this->set_is_boss(true);
	_ai_state.initial_position.y = -200;
	position.y = _ai_state.initial_position.y;
    hitPoints.total = PLAYER_INITIAL_HP;
    hitPoints.current = hitPoints.total;
    hit_duration = BOSS_HIT_DURATION;
	//std::cout << "classboss::classboss [" << name << "] - is_boss: " << _is_boss << std::endl;
}

classboss::classboss(int stage_id, int map_id, int main_id, int id) : classnpc(stage_id, map_id, main_id, id)
{
	_initialized = 0;
	_screen_blinked = false;
	this->set_is_boss(true);
    _ai_state.initial_position.y = -(frameSize.height+1);
	position.y = _ai_state.initial_position.y;
	hitPoints.total = PLAYER_INITIAL_HP;
    hitPoints.current = hitPoints.total;
    hit_duration = BOSS_HIT_DURATION;
	//std::cout << "BOSS 1 - stage_id: " << stage_id << ", map_id: " << map_id << ", main_id: " << main_id << ", id: " << id << std::endl;
}


void classboss::boss_move() {
    //std::cout << "classboss::boss_move - _initialized: " << _initialized << std::endl;

    move_projectiles();
    //std::cout << "PSP DEBUG - #H.1" << std::endl;

    if (_initialized == 0 && _is_boss == true) { /// @TODO: move this logic to map (player should not move while boss is presenting)
        //std::cout << "PSP DEBUG - #H.2" << std::endl;
		_initialized++;
        set_animation_type(ANIM_TYPE_TELEPORT);
        //std::cout << "PSP DEBUG - #4.1" << std::endl;
        gameControl.boss_intro(_is_boss);
        //std::cout << "PSP DEBUG - #4.2" << std::endl;
		return;
    } else if (_initialized == 1 && _is_boss == true) {
        //std::cout << "PSP DEBUG - #5 - _initialized: " << _initialized << std::endl;
		if (position.x > RES_H/3 && gravity(true) == false) {
            std::cout << "PSP DEBUG - #5.1" << std::endl;
			_initialized++;
		}
        //std::cout << "PSP DEBUG - #5.2" << std::endl;
        state.move_timer = timer.getTimer()+30;
		return;
	}
    //std::cout << "PSP DEBUG - #5.3" << std::endl;


	if (first_run == 0) {
		first_run = 1;
	}

	if (_ai_timer > timer.getTimer()) {
        return;
	}
    //std::cout << "PSP DEBUG - #6" << std::endl;

    execute_ai();
    //std::cout << "PSP DEBUG - #7" << std::endl;
    gravity(false);
    //std::cout << "PSP DEBUG - #8" << std::endl;
}

// ********************************************************************************************** //
//                                                                                                //
// ********************************************************************************************** //
void classboss::execute()
{
	if (hitPoints.current <= 0 || position.x < map->getMapScrolling().x-TILESIZE*2 || position.x > map->getMapScrolling().x+RES_W+TILESIZE*2) {
		return;
	}
	if (last_execute_time > timer.getTimer()) {
		return;
	}
	if (state.move_timer > timer.getTimer()) {
		move_projectiles();
		return;
	}
	//std::cout << "classboss::execute" << std::endl;
	boss_move();
	charMove();
}



void classboss::death()
{
    state.jump_state = NO_JUMP;
    dead = true;
    if (_ai_state.main_status == IA_STATE_QUAKE_ATTACK) {
        graphLib.set_screen_adjust(st_position(0, 0));
    }
}

bool classboss::is_boss()
{
    return true;
}
