#ifndef CLASSMAP_H
#define CLASSMAP_H


#include "defines.h"
#include "st_common.h"
#include "graphicslib.h"
#include "character/classnpc.h"
#include "objects/object.h"
#include "graphic/animation.h"
#include <list>
#include <vector>

#define EXPLOSION_ANIMATION_TIME 50

class classPlayer; // forward declaration

class character;

/**
 * @brief
 *
 */
struct object_colision {
    int _block; /**< TODO */
    object* _object; /**< TODO */
	object_colision(int set_block, object* set_object) {
		_block = set_block;
		_object = set_object;
	}
};


/**
 * @brief
 *
 */
class classMap
{
public:
	classMap();
    /**
     * @brief
     *
     */
    ~classMap();
    /**
     * @brief
     *
     * @param theElement
     * @return bool
     */
    static bool deleteAll( classMap* theElement );
    /**
     * @brief
     *
     * @param int
     */
    /**
     * @brief
     *
     */
    void setStageNumber(int);
    /**
     * @brief
     *
     * @return short
     */
    short get_stage_number();
    /**
     * @brief
     *
     * @return short
     */
    short get_number();
    /**
     * @brief
     *
     * @param int
     */
    void setMapNumber(int);
    /**
     * @brief
     *
     */
    void loadMap();
    /**
     * @brief
     *
     */
    void drawMap();
    /**
     * @brief
     *
     */
    void showMap();
    /**
     * @brief
     *
     * @param scroll_y
     */
    void showAbove(int scroll_y=0);
    /**
     * @brief
     *
     * @param pos
     * @return bool
     */
    bool is_point_solid(st_position pos);
    /**
     * @brief
     *
     * @param pos
     * @return int
     */
    int getMapPointLock(st_position pos);
    /**
     * @brief
     *
     * @param x
     * @return bool
     */
    bool get_map_point_wall_lock(int x);
    /**
     * @brief
     *
     * @param pos
     * @param check_lock
     */
    void changeScrolling(st_position pos, bool check_lock=true);
    /**
     * @brief
     *
     * @return st_position
     */
    st_position getMapScrolling();
    /**
     * @brief
     *
     * @param n
     * @return std::string
     */
    std::string cent_number(int n);
    /**
     * @brief
     *
     * @return st_position
     */
    st_position get_last_scrolled();
    /**
     * @brief
     *
     */
    void reset_scrolled();
    /**
     * @brief
     *
     */
    void load_map_objects();
    /**
     * @brief
     *
     * @param
     * @param short
     * @param short
     * @param short
     * @param short
     * @return object_colision
     */
    object_colision colision_player_object(character*, const short int, const short int, short int, short int);
    /**
     * @brief
     *
     * @param
     * @param short
     * @param short
     * @param short
     * @param short
     * @return short
     */
    short int colision_player_npcs(character*, const short int, const short int, short int, short int);
    /**
     * @brief
     *
     */

    classnpc* find_nearest_npc(st_position pos);
    /**
     * @brief
     *
     */

    void clean_map_npcs_projectiles();
    /**
     * @brief
     *
     * @return graphicsLib_gSurface
     */
    graphicsLib_gSurface* get_map_surface();
    /**
     * @brief
     *
     * @param pos
     */
    void set_scrolling(st_position pos);
    /**
     * @brief
     *
     * @param move_x
     * @param move_y
     */
    void move_map(const short int move_x, const short int move_y);
    /**
     * @brief
     *
     */
    void clean_map();
    /**
     * @brief
     *
     */
    void reset_map();
    /**
     * @brief
     *
     * @param is_close
     * @param nTiles
     * @param tileX
     * @param player_number
     */
    void redraw_boss_door(bool is_close, int nTiles, int tileX, short player_number);
    /**
     * @brief
     *
     * @param pos_type
     * @param surface
     * @param pos
     * @param adjust_pos
     * @param frame_time
     * @param repeat_times
     * @param direction
     * @param framesize
     */
    void add_animation(ANIMATION_TYPES pos_type, graphicsLib_gSurface* surface, const st_float_position &pos, st_position adjust_pos, unsigned int frame_time, unsigned int repeat_times, int direction, st_size framesize);
    /**
     * @brief
     *
     */
    void clear_animations(); // remove all animations from map
    /**
     * @brief
     *
     * @param player_list
     */
    void set_player_list(std::vector<classPlayer*> player_list);
    /**
     * @brief
     *
     * @param npc_id
     * @param npc_pos
     * @param direction
     */
    void spawn_map_npc(short int npc_id, st_position npc_pos, short direction, bool player_friend);
    /**
     * @brief
     *
     */
    void move_npcs();
    /**
     * @brief
     *
     */
    void show_npcs();
    /**
     * @brief
     *
     */
    void move_objects();
    /**
     * @brief
     *
     * @return bool
     */
    bool boss_hit_ground();
    /**
     * @brief
     *
     */
    void reset_map_npcs();
    /**
     * @brief
     *
     * @param surface
     */
    void draw_dynamic_backgrounds_into_surface(graphicsLib_gSurface &surface, int x_adjust, int y_adjust);
    /**
     * @brief
     *
     * @param obj
     */
    void add_object(object obj);
    /**
     * @brief
     *
     * @param x_pos
     * @return int
     */
    int get_first_lock_on_left(int x_pos);

    /**
     * @brief
     *
     * @param x_pos
     * @return int
     */
    int get_first_lock_on_right(int x_pos);


    /**
     * @brief
     *
     * @param pos
     */
    void drop_item(st_position pos);

    void set_bg1_scroll(int scrollx);
    void set_bg2_scroll(int scrollx);
    int get_bg1_scroll();
    int get_bg2_scroll();

private:
    /**
     * @brief
     *
     */
    void load_map_npcs();
    /**
     * @brief
     *
     */
    void draw_dynamic_backgrounds();
    /**
     * @brief
     *
     * @param value
     * @param min
     * @param max
     * @return bool
     */
    bool value_in_range(int value, int min, int max);

    /**
     * @brief
     *
     */
    void create_dynamic_background_surfaces();

    /**
     * @brief
     *
     */
    void create_dynamic_background_surface(graphicsLib_gSurface& dest_surface, graphicsLib_gSurface& image_surface);

public:
    struct format_v_2_0_3::file_map map_tiles; /**< TODO */
    std::list<classnpc*> _npc_list; // vector npcs /**< TODO */
    std::vector<classPlayer*> _player_list; // vector players /**< TODO */
    std::list<animation> animation_list; /**< TODO */
	// vector teleporters
	// vector objects
    int number; /**< TODO */

private:
    int stage_number; /**< TODO */
    graphicsLib_gSurface mapSurface; /**< TODO */
    struct st_position scroll; /**< TODO */
    st_position scrolled;						// stores the value the map scrolled in this cycle. used for character movement control (it should move taking the scroll in account) /**< TODO */
    std::list<object> object_list; /**< TODO */
    bool wall_scroll_lock[MAP_W]; /**< TODO */
    float bg1_scroll; /**< TODO */
    float bg2_scroll; /**< TODO */
    graphicsLib_gSurface bg1_surface; /**< TODO */
    graphicsLib_gSurface bg2_surface; /**< TODO */
    short _platform_leave_counter; /**< TODO */

};



#endif // CLASSMAP_H
