#include <cstdlib>
#include "file_io.h"
#include "convert.h"

extern std::string FILEPATH;


namespace format_v_2_1_1 {

    file_io::file_io()
    {
    }

    void file_io::write_game(format_v_2_1_1::file_game& data_in) {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v211.dat";

        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }

        fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_1_1::file_game));
        fp.close();

        // ----------------------- STAGES ----------------------- //

    }

    void file_io::write_all_stages(format_v_2_1_1::file_stages &stages_data_in)
    {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }
        fp.write(reinterpret_cast<char *>(&stages_data_in), sizeof(struct format_v_2_1_1::file_stages));
        fp.close();
    }



    void file_io::read_game(format_v_2_1_1::file_game& data_out) {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/game_v211.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            std::cout << "ERROR: Could not read save 211" << std::endl;
            exit(-1);
        }
        fread(&data_out, sizeof(struct format_v_2_1_1::file_game), 1, fp);
        fclose(fp);
    }


    void file_io::read_all_stages(format_v_2_1_1::file_stages& stages_data_out)
    {
        std::ifstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
        if (!fp.is_open()) {
            std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
            exit(-1);
        }
        fp.read(reinterpret_cast<char *>(&stages_data_out), sizeof(struct format_v_2_1_1::file_stages));
        fp.close();
    }

    void file_io::read_stage(format_v_2_0_3::file_stage &stages_data_out, short stage_n)
    {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v211.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            fclose(fp);
            std::cout << "ERROR: Could not read stages 211" << std::endl;
            exit(-1);
        }
        fseek(fp, sizeof(format_v_2_0_3::file_stage) * stage_n, SEEK_SET);
        fread(&stages_data_out, sizeof(struct format_v_2_0_3::file_stage), 1, fp);
        fclose(fp);

    }


}



namespace format_v_2_1_2 {

    file_io::file_io()
    {

    }


    void file_io::write_game(format_v_2_1_2::file_game& data_in) {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/game_v212.dat";

        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }

        fp.write(reinterpret_cast<char *>(&data_in), sizeof(struct format_v_2_1_2::file_game));
        fp.close();

        // ----------------------- STAGES ----------------------- //

    }

    void file_io::write_all_stages(format_v_2_1_2::file_stages &stages_data_in)
    {
        std::ofstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v212.dat";
        fp.open(filename.c_str(), std::ios::out | std::ios::binary | std::ios::ate);
        if (!fp.is_open()) {
            std::cout << "ERROR::write_game - could not write to file '" << filename << std::endl;
            return;
        } else {
            std::cout << "fio::write_game - recorded to file '" << filename << std::endl;
        }
        fp.write(reinterpret_cast<char *>(&stages_data_in), sizeof(struct format_v_2_1_2::file_stages));
        fp.close();
    }



    void file_io::read_game(format_v_2_1_2::file_game& data_out) {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/game_v212.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            exit(-1);
        }
        fread(&data_out, sizeof(struct format_v_2_1_2::file_game), 1, fp);
        fclose(fp);
    }


    void file_io::read_all_stages(format_v_2_1_2::file_stages& stages_data_out)
    {
        std::ifstream fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v212.dat";
        fp.open(filename.c_str(), std::ios::in | std::ios::binary | std::ios::app);
        if (!fp.is_open()) {
            std::cout << "ERROR::read_game - could not load file '" << filename << std::endl;
            exit(-1);
        }
        fp.read(reinterpret_cast<char *>(&stages_data_out), sizeof(struct format_v_2_1_2::file_stages));
        fp.close();
    }

    void file_io::read_stage(file_stage &stages_data_out, short stage_n)
    {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/stages_v212.dat";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            fclose(fp);
            std::cout << "ERROR: Could not read stages 211" << std::endl;
            exit(-1);
        }
        fseek(fp, sizeof(file_stage) * stage_n, SEEK_SET);
        fread(&stages_data_out, sizeof(struct file_stage), 1, fp);
        fclose(fp);

    }

    bool file_io::file_exists(std::string filename)
    {
        bool res = false;
        FILE *fp;
        fp = fopen(filename.c_str(), "rb");
        if (fp) {
            res = true;
            fclose(fp);
        }
        return res;
    }

    void file_io::check_conversion()
    {
        std::cout << ">>> file_io::file_io" << std::endl;
        std::string filename_v211 = std::string(FILEPATH) + "data/game_v211.dat";
        std::string filename_v212 = std::string(FILEPATH) + "data/game_v212.dat";
        if (file_exists(filename_v212) == false && file_exists(filename_v211) == true) {
            std::cout << ">>> file_io::file_io - CONVERT 211 to 212" << std::endl;
            convert convert_obj;
            convert_obj.v211_to_v212();
        }
    }

    bool file_io::save_exists()
    {
        std::string filename = std::string(FILEPATH) + "data/game212.sav";
        std::ifstream fp(filename.c_str());
        if (fp.good()) {
            return true;
        }
        return false;
    }

    void file_io::read_save(format_v_2_1_2::st_save& data_out)
    {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "data/game212.sav";
        fp = fopen(filename.c_str(), "rb");
        if (!fp) {
            fclose(fp);
            std::cout << "ERROR: Could not read save" << std::endl;
            exit(-1);
        }
        fread(&data_out, sizeof(struct format_v_2_1_2::st_save), 1, fp);
        // ------- DEBUG ------- //
        /*
        for (int i=0; i<STAGE_COUNT; i++) {
            data_out.stages[i] = 1;
        }
        */
        data_out.items.lifes = 0;
        if (data_out.items.lifes > 9) {
            data_out.items.lifes = 3;
        }

        fclose(fp);
    }

    void file_io::write_save(format_v_2_1_2::st_save& data_in)
    {
        FILE *fp;
        std::string filename = std::string(FILEPATH) + "/data/game212.sav";
        fp = fopen(filename.c_str(), "wb");
        if (!fp) {
            std::cout << "Error: Could not open save-file '" << filename << "'." << std::endl;
            exit(-1);
        }
        fwrite(&data_in, sizeof(struct format_v_2_1_2::st_save), 1, fp);
        fclose(fp);
    }
}


