#include "draw.h"

#define RAIN_DELAY 160

extern graphicsLib graphLib;

#include "timerlib.h"
extern timerLib timer;

draw::draw() : _rain_pos(0), _rain_timer(0), _rain_enabled(false)
{
}

void draw::update_screen()
{
    if (_rain_enabled == true) {
        show_rain();
    }
    graphLib.updateScreen();
}

void draw::set_rain_enabled(bool enabled)
{
    _rain_enabled = enabled;
}

void draw::show_rain()
{
    if (rain_obj.gSurface == NULL) {
        // load rain
        std::string filename = FILEPATH + "/data/images/tilesets/rain.png";
        graphLib.surfaceFromFile(filename, &rain_obj);
    }
    for (int i=0; i<MAP_W; i++) {
        for (int j=0; j<MAP_H; j++) {
            graphLib.showSurfaceRegionAt(&rain_obj, st_rectangle(_rain_pos*TILESIZE, 0, TILESIZE, TILESIZE), st_position(i*TILESIZE, j*TILESIZE));
        }
    }
    if (timer.getTimer() > _rain_timer) {
        _rain_pos++;
        if (_rain_pos > 2) {
            _rain_pos = 0;
        }
        _rain_timer = timer.getTimer() + RAIN_DELAY;
    }
}

