#ifndef PSP_CALLBACKS_H
#define PSP_CALLBACKS_H

#include <pspkernel.h>

static int exitRequest = 0; /**< TODO */

/**
 * @brief
 *
 * @return int
 */
int isRunning()
{
		return !exitRequest;
}

/**
 * @brief
 *
 * @param arg1
 * @param arg2
 * @param common
 * @return int
 */
int exitCallback(int arg1, int arg2, void *common)
{
		exitRequest = 1;
		return 0;
}

/**
 * @brief
 *
 * @param args
 * @param argp
 * @return int
 */
int callbackThread(SceSize args, void *argp)
{
		int callbackID;

		callbackID = sceKernelCreateCallback("Exit Callback", exitCallback, NULL);
		sceKernelRegisterExitCallback(callbackID);

		sceKernelSleepThreadCB();

		return 0;
}

/**
 * @brief
 *
 * @return int
 */
int setupExitCallback()
{
		int threadID = 0;

		threadID = sceKernelCreateThread("Callback Update Thread", callbackThread, 0x11, 0xFA0, THREAD_ATTR_USER, 0);

		if(threadID >= 0)
		{
				sceKernelStartThread(threadID, 0, 0);
		}

		return threadID;
}

#endif // PSP_CALLBACKS_H
