#ifndef STAGE_H
#define STAGE_H

#include "classmap.h"
#include "character/character.h"
#include "character/classplayer.h"

#define PRELOAD_MAP_N 3

/**
 * @brief
 *
 */
class stage
{
public:
	stage(int, std::vector<classPlayer> &set_player_list);
    /**
     * @brief
     *
     */
    ~stage();
     /**
     * @brief
     * @return classMap
     */
    void setNumber(int);
    /**
     * @brief
     * @param int
     */
    void loadStage();
    /**
     * @brief
     *
     */
    void showStage();
    /**
     * @brief
     *
     * @param st_position
     * @return int
     */
    int getMapPointLock(struct st_position);
    /**
     * @brief
     *
     * @param pos
     * @param check_lock
     */
    void changeScrolling(st_position pos, bool check_lock=true);
    /**
     * @brief
     *
     * @return st_position
     */
    st_position getMapScrolling();
    /**
     * @brief
     *
     * @param scroll_y
     */
    void showAbove(int scroll_y=0);
    /**
     * @brief
     *
     * @return classMap
     */
    classMap* get_current_map();
    /**
     * @brief
     *
     * @return int
     */
    int get_current_map_number();
    /**
     * @brief
     *
     * @param int
     */
    void set_current_map(int);
    /**
     * @brief
     *
     * @return short
     */
    short int get_current_map_n();
    /**
     * @brief
     *
     * @param pos
     */
    void set_scrolling(st_position pos);
    /**
     * @brief
     *
     * @param move_x
     * @param move_y
     */
    void move_map(const short int move_x, const short int move_y);
    /**
     * @brief
     *
     */
    void reload_stage(); // reload maps npc and object list
    /**
     * @brief
     *
     */
    void reset_current_map();
    /**
     * @brief
     *
     */
    void reset_current_map_objects();
    /**
     * @brief
     *
     */
    void reset_stage_objects();
    /**
     * @brief
     *
     */
    void clean_stage();
    /**
     * @brief
     *
     * @param is_close
     * @param nTiles
     * @param tileX
     * @param player_number
     */
    void redraw_boss_door(bool is_close, int nTiles, int tileX, short player_number);
    /**
     * @brief
     *
     */
    void move_npcs();
    /**
     * @brief
     *
     */
    void show_npcs();
    /**
     * @brief
     *
     */
    void move_objects();
    /**
     * @brief
     *
     * @return bool
     */
    bool boss_hit_ground();
    /**
     * @brief
     *
     */
    void reset_stage_maps();
    /**
     * @brief
     *
     */
    void reset_stage_npcs();
    /**
     * @brief
     *
     * @param x_pos
     * @return int
     */
    int get_first_lock_on_left(int x_pos);

    int get_teleport_minimal_y(int xpos);


public:
    classMap* maps[PRELOAD_MAP_N]; /**< TODO */

private:
    int number; /**< TODO */
    int currentMap; /**< TODO */
    std::vector<classPlayer*> _player_list; /**< TODO */

    int _color1_timer; /**< TODO */
    int _color2_timer; /**< TODO */
    int _color3_timer; /**< TODO */

    int _color1_n; /**< TODO */
    int _color2_n; /**< TODO */
    int _color3_n; /**< TODO */

};

#endif // STAGE_H
